part of '../../../../moru_payment_gateway.dart';

GetIt getIt = GetIt.instance;

class CheckoutCubit extends Cubit<CheckoutState> {
  CheckoutCubit() : super(ValidateAccessKeyInitial()) {
    try {
      getIt.registerLazySingleton<PaymentImpl>(
        () => PaymentImpl(
          paymentHandler: PaymentHandler(
            dio: Dio(),
          ),
        ),
      );
    } catch (_) {}
  }

  void initiatePay({required CheckoutOptions checkoutOptions}) async {
    try {
      emit(ValidateAccessLoading());
      final ValidatedAccessRes? accessRes = await getIt<PaymentImpl>()
          .validateAccess(checkoutOptions: checkoutOptions);
      if (accessRes != null) {
        emit(ValidateAccessSuccess(accessRes: accessRes));
      }
    } on String catch (e) {
      emit(ValidateAccessFail(failedReason: e));
    } catch (_, s) {
      print(_.toString());
      emit(ValidateAccessFail(failedReason: "Unable to process your request"));
    }
  }
}
